SystemOrganization addCategory: #'GT-Playground'!

!GLMSystemWindow methodsFor: '*GT-Playground' stamp: 'AndreiChis 9/8/2014 22:56'!
acceptAction: anAction 
	"Be compatible with edit:label:accept:.
	Not the best place for this method.
	Interim situation to move things forward..."
	self flag: #TODO.
	self model ifNotNil: [:aModel | aModel acceptAction: anAction].! !

!GLMSystemWindow methodsFor: '*GT-Playground' stamp: 'AndreiChis 9/8/2014 22:55'!
acceptContents: aString 
	"Be compatible with edit:label:accept:.
	Not the best place for this method.
	Interim situation to move things forward..."
	self flag: #TODO.
	self model ifNotNil: [:aModel | aModel acceptContents: aString].

	! !

Object subclass: #GTPlayBook
	instanceVariableNames: 'pages'
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'GT-Playground'!

GTPlayBook class
	instanceVariableNames: 'cacheDirectory'!

!GTPlayBook commentStamp: 'TudorGirba 10/22/2014 07:51' prior: 0!
This class holds the pages that are loaded in the image.

At class initialization time, it loads pages from the cacheDirectory and then maintains the pages in memory.!

GTPlayBook class
	instanceVariableNames: 'cacheDirectory'!

!GTPlayBook class methodsFor: 'accessing' stamp: 'AndreiChis 11/5/2014 19:14'!
cacheDirectory
	^ cacheDirectory 
		ifNil: [cacheDirectory := self defaultCacheDirectory]
		ifNotNil: [ cacheDirectory exists 
			ifTrue: [ cacheDirectory ]
			ifFalse: [ cacheDirectory := self defaultCacheDirectory ] ]! !

!GTPlayBook class methodsFor: 'accessing' stamp: 'TudorGirba 10/20/2014 16:40'!
cacheDirectory: aString 
	cacheDirectory := aString asFileReference! !

!GTPlayBook class methodsFor: 'protocol' stamp: 'TudorGirba 12/5/2014 00:05'!
cleanUp
	
	instance := nil! !

!GTPlayBook class methodsFor: 'accessing' stamp: 'AndreiChis 11/5/2014 19:14'!
defaultCacheDirectory
	^ 'play-cache/' asFileReference ensureCreateDirectory! !

!GTPlayBook class methodsFor: 'accessing' stamp: 'TudorGirba 10/18/2014 21:48'!
instance
	^ instance ifNil: [ instance := self new ]! !

!GTPlayBook class methodsFor: 'protocol' stamp: 'TudorGirba 10/19/2014 21:34'!
reset
	
	instance := nil! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 10/18/2014 22:13'!
addPage: aPage
	self pages addFirst: aPage! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 12/5/2014 14:14'!
addPageIfInteresting: aPage
	aPage content asString trimBoth isEmpty ifTrue: [ ^ self ].
	self addPage: aPage! !

!GTPlayBook methodsFor: 'ui' stamp: 'TudorGirba 11/2/2014 22:01'!
gtPagesIn: composite
	<gtInspectorPresentationOrder: 0>
	composite list 
		title: 'Pages';
		display: [ self pages ];
		format: #gtDisplayString;
		filterOn: [ :text :each | text match: each content]! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 12/29/2014 22:08'!
initialize
	|files|
	files := ((self class cacheDirectory files 
		select: [ :each | each extension = 'ph' ])).
	files size > 100 ifTrue: [files := files first: 100]. 
	pages := OrderedCollection new.
	files do: [ :each | 
		[ pages add: (GTPlayPage new content: (each readStreamDo: #contents)) ]
			on: Error 
			do: [  ] ]! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 10/18/2014 21:49'!
pages
	^ pages! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 10/18/2014 21:49'!
pages: anObject
	pages := anObject! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 10/18/2014 21:51'!
removePage: aPage
	self pages remove: aPage! !

Object subclass: #GTPlayPage
	instanceVariableNames: 'title content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlayPage commentStamp: 'TudorGirba 10/22/2014 07:52' prior: 0!
It holds one page of code. It is the model behind the Playground.

It also knows how to store itself on disk, and every time its content changes, it updates the corresponding file.!

!GTPlayPage methodsFor: 'compatibility-tools' stamp: 'AndreiChis 9/30/2014 20:44'!
acceptContents: aString

	self flag: #TODO. "Need support for what lies in the comment down here"
	"self fileName ifNotNil: [ self saveString: aString toFile: self fileName ].

	acceptAction ifNotNil:[acceptAction value: aString]."
	self content: aString.
	^ true! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 10/19/2014 21:34'!
cacheDirectory
	^ GTPlayBook cacheDirectory! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
content
	^ content! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 10/19/2014 21:21'!
content: aString
	content := aString.
	aString isEmpty 
		ifTrue: [ self fileReference ensureDelete ]
		ifFalse: [ self fileReference writeStreamDo: [ :s | s nextPutAll: aString ] ]! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 10/19/2014 21:25'!
fileReference

	^ self cacheDirectory / (self title, '.ph')! !

!GTPlayPage methodsFor: 'ui' stamp: 'TudorGirba 11/2/2014 22:03'!
gtDisplayOn: stream
	stream nextPutAll: (self content asString copyReplaceAll: String cr with: String space)! !

!GTPlayPage methodsFor: 'ui' stamp: 'TudorGirba 11/2/2014 22:14'!
gtInspectorContentIn: composite
	<gtInspectorPresentationOrder: 0>
	composite pharoPlayground 
		title: 'Content';
		display: #content;
		installGoAction;
		installDefaultSelectionActions! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 10/19/2014 13:47'!
initialize
	content := ''.
	title := (DateAndTime now asString copyReplaceAll: ':' with: '-') copyReplaceAll: '.' with: '-'! !

!GTPlayPage methodsFor: 'accessing' stamp: 'AndreiChis 12/9/2014 15:00'!
publishUrl
	| url |
	(self confirm: 'Publish playground content to the cloud?')
        ifFalse: [ ^ self ].
    self content ifEmpty: [ 
        self inform: 'Nothing was published because the playground is empty'.
        ^ self ].
    url := GTUrlProvider new post: self content.
    Clipboard clipboardText: url asString.
    self inform: url asString , ' was published and the url was copied to clipboard'! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 10/20/2014 15:30'!
silentContent: aString
	content := aString! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
title
	^ title! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
title: anObject
	title := anObject! !

Object subclass: #GTUrlProvider
	instanceVariableNames: 'urlProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

GTUrlProvider class
	instanceVariableNames: 'urlProvider'!

!GTUrlProvider commentStamp: 'TudorGirba 10/22/2014 07:50' prior: 0!
This class was inspired from the Zinc SharedWorkspace project.

Its job is to work with a UrlProvider that can provide (via get) and store (via post) strings.!

GTUrlProvider class
	instanceVariableNames: 'urlProvider'!

!GTUrlProvider class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 10/22/2014 08:02'!
settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #stringUrlProvider)
		parent: #gt;
		target: self;
		description: 'The url for the script sharing service like the one from http://ws.stfx.eu' translated;
		label: 'The url for the script sharing service'
! !

!GTUrlProvider class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 10/22/2014 08:02'!
stringUrlProvider
	^ self urlProvider asString! !

!GTUrlProvider class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 10/22/2014 08:01'!
stringUrlProvider: aString
	self urlProvider: aString! !

!GTUrlProvider class methodsFor: 'accessing' stamp: 'TudorGirba 10/22/2014 07:48'!
urlProvider
	^ urlProvider ifNil: [ urlProvider := 'http://ws.stfx.eu' asZnUrl ]! !

!GTUrlProvider class methodsFor: 'accessing' stamp: 'TudorGirba 10/22/2014 07:48'!
urlProvider: aUrlObject
	urlProvider := aUrlObject ifNotNil: [ aUrlObject asZnUrl ]! !

!GTUrlProvider methodsFor: 'public' stamp: 'TudorGirba 10/22/2014 07:50'!
get: url	
	| contents |
	contents := self httpClient get: url.
	^ String new: contents size streamContents: [ :stream |
		contents linesDo: [ :each | stream nextPutAll: each; cr ] ]! !

!GTUrlProvider methodsFor: 'private' stamp: 'TudorGirba 10/22/2014 07:47'!
httpClient
	^ ZnClient new
		systemPolicy;
		beOneShot;
		accept: ZnMimeType textPlain;
		url: self urlProvider;
		yourself! !

!GTUrlProvider methodsFor: 'public' stamp: 'TudorGirba 10/22/2014 07:53'!
post: string
	| entity client url |
	entity := ZnEntity text: string asString.
	(client := self httpClient)
		entity: entity; 
		post.
	url := client response location.
	^ url asZnUrl inContextOf: self urlProvider ! !

!GTUrlProvider methodsFor: 'public' stamp: 'TudorGirba 10/22/2014 07:49'!
urlProvider
	^ urlProvider ifNil: [ urlProvider := self class urlProvider ]! !

!GTUrlProvider methodsFor: 'initialize-release' stamp: 'TudorGirba 10/22/2014 07:49'!
urlProvider: anUrlObject
	urlProvider := anUrlObject asZnUrl ! !

GLMCompositePresentation subclass: #GTPlayground
	instanceVariableNames: ''
	classVariableNames: 'GTPlaygroundEnabledStatus'
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlayground commentStamp: 'TudorGirba 10/22/2014 07:37' prior: 0!
Playground is the correspondent of a classic Smalltalk Workspace. The problem with the name Workspace is that it implies that work should be carried out in this space, while this is not a best practice. Playground describes better the intention of providing a place in which we can quickly play with some code.

The model behind a Playground instance is a PlayPage object.

!!!!Use cases
The Playground can be used in two ways

# As a place to construct and try out code snippets.
# as an entry point into an inspection process.

In both cases, the ability of diving into objects to the right is an important feature.

!!!!Running
[ [ [ 
	self open.
 ] ] ]!

!GTPlayground class methodsFor: 'compatibility-tools' stamp: 'TudorGirba 10/18/2014 21:52'!
edit: aString label: aLabel

"Open a new playground with the given contents"
"Compatibility with the original Workspace"
"#edit: aText label: labelString accept: anAction"
"	^(Smalltalk tools workspace openLabel: labelString)
		acceptContents:  aText;
		acceptAction: anAction;
		yourself."

"Open an editor on the given string/text"
	| page |
	"self halt"

	page := GTPlayPage new
		content: aString;
		title: aLabel;
		yourself.
		
	self flag: #TODO. "We need to put an equivalent to the acceptAction thing."
	^ self new openOn: page! !

!GTPlayground class methodsFor: 'settings' stamp: 'AndreiChis 8/29/2014 00:39'!
isGTPlaygroundEnabled

	^ GTPlaygroundEnabledStatus ifNil: [ GTPlaygroundEnabledStatus := Smalltalk tools workspace = self ]! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 10/18/2014 21:52'!
open
	"self open"
	| page |
	page := GTPlayPage new.
	^ self new openOn: page! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 10/18/2014 21:52'!
openContents: aString
	"Open a new playground with the given contents. aString has to be Smalltalk code. The style is applied"
	

	| page |
	
	page := GTPlayPage new
		content: aString;
		yourself.
	^ self new openOn: page! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 10/18/2014 21:52'!
openContents: aString label: aLabel
	"Open a new playground with the given contents"

	| page |

	page := GTPlayPage new
		content: aString;
		title: aLabel;
		yourself.
	^ self new openOn: page! !

!GTPlayground class methodsFor: 'compatibility-tools' stamp: 'TudorGirba 10/18/2014 21:52'!
openLabel: aLabel
	| page |

	page := GTPlayPage new
		title: aLabel;
		yourself.
	^ self new openOn: page! !

!GTPlayground class methodsFor: 'tools registry' stamp: 'AndreiChis 8/28/2014 21:33'!
register

	self registerToolsOn: Smalltalk tools! !

!GTPlayground class methodsFor: 'tools registry' stamp: 'TudorGirba 2/9/2014 01:10'!
registerToolsOn: registry
	"Add ourselves to registry. See [Smalltalk tools]"
	"self registerToolsOn: Smalltalk tools" 
	registry register: self as: #workspace
! !

!GTPlayground class methodsFor: 'settings' stamp: 'AndreiChis 8/28/2014 21:33'!
setGTPlaygroundEnabledStatus: aBoolean
	| oldStatus |
	
	oldStatus := self isGTPlaygroundEnabled.
	GTPlaygroundEnabledStatus := aBoolean.
	oldStatus ~= GTPlaygroundEnabledStatus ifTrue: [ 
		GTPlaygroundEnabledStatus 
			ifTrue: [ self register ]
			ifFalse: [ Workspace registerToolsOn: Smalltalk tools ] ]
	
	! !

!GTPlayground class methodsFor: 'settings' stamp: 'TudorGirba 10/20/2014 16:39'!
settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #GTPlaygroundStatus)
		target: self;
		parent: #gt;
		getSelector: #isGTPlaygroundEnabled;
		setSelector: #setGTPlaygroundEnabledStatus:; 
		label: 'GTPlayground';
		description: 'Enable or disable the GTPlayground.'.
	(aBuilder setting: #cacheDirectory)
		parent: #gt;
		type: #Directory;
		target: GTPlayBook;
		description: 'The path to the local Playground cache that stores all Playground scripts in ph files' translated;
		label: 'Local Playground cache directory'
! !

!GTPlayground class methodsFor: 'tools registry' stamp: 'TudorGirba 2/11/2014 22:23'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^ Smalltalk ui icons iconNamed: #workspaceIcon! !

!GTPlayground methodsFor: 'accessing' stamp: 'AndreiChis 9/8/2014 23:02'!
acceptAction: anAction
	"acceptAction := anAction."! !

!GTPlayground methodsFor: 'accessing' stamp: 'AndreiChis 9/30/2014 20:46'!
acceptContents: aString

	^ (self entity acceptContents: aString)
		ifTrue: [  
			self update.
			true]! !

!GTPlayground methodsFor: 'building' stamp: 'TudorGirba 10/20/2014 15:38'!
actionsForPreviousContents
	^ GTPlayBook instance pages
		collect: [ :each | 
			GLMGenericAction new
				title: (each content asString contractTo: 50);
				action: [ :text | 
					text entity content: each content.
					text update ];
				yourself ]! !

!GTPlayground methodsFor: 'building' stamp: 'TudorGirba 10/21/2014 23:15'!
codeIn: a
	^ a pharoPlayground
		title: [ :page | page title ];
		format: [ :page | page content ];
		act: [ :text :page |
				text selectionInterval: (1 to: text text size).
				text evaluateSelectionAndDo: [ :result | text selection: result ] ]
			icon: GLMUIThemeExtraIcons glamorousGo
"			on: $G"
			entitled: 'Do it all and go';
		installGoAction;
		installDefaultSelectionActions;
		act: [ :text :page | page publishUrl ]
			icon: GLMUIThemeExtraIcons glamorousSaveToUrl
			entitled: 'Remote publish';
		dynamicActions: [ self actionsForPreviousContents ];
		onChangeOfPort: #text act: [ :text :page | page content: text text ]! !

!GTPlayground methodsFor: 'building' stamp: 'TudorGirba 10/20/2014 07:11'!
compose
	self
		title: 'Playground';
		custom:
			(GTInspector new
				noTitle; 
				noActions;
				showFirst: [ :composite |
					self codeIn: composite ];
				yourself);
		on: GLMBrowserClosing do: [ 
			"This is a hack for the moment.
			We need a better mechanism from Glamour to help 
			us keep the model in sync"
			self entity
					content: self first panes first presentations first text.
			GTPlayBook instance addPageIfInteresting: self entity ]! !
